var ActionModal = Vue.component('ActionModal', {
	props: ['action'],
	events: ['saved'],
	template:'#action-modal-template',
	methods: {
		save: function() {
			var $self = this;			
			
			$.ajax({
				method: "POST",
				url: Ekey.Url.ActionsSave,
				dataType: "text",
				data: 'data=' + encodeURIComponent(JSON.stringify(this.action))
			})
			.done(function (response) {
				var result = JSON.parse(response);				
				
				if (result.success) {
					$self.$parent.close();
					$self.$emit("saved");					
				} else {
					console.log(response);
				}
			})
			.fail(function(xhr, textStatus, errorThrown){
				console.log(textStatus);
			});			
		}
	}
});

Vue.component('actions-list', {
    data: function () {
        return {
            data: [],
            loading: false,
            selected: null
        }
    },
    methods: {
        loadAsyncData: function() {
            var $self = this;
            this.loading = true;
            this.data = [];

            $.ajax({
                method: "GET",
				cache: false,
                url: Ekey.Url.ActionsList,
                dataType: "json"
            })
            .done(function (response) {
                $self.data = response.data;
                $self.loading = false;
            })
            .fail(function () { })
            .always(function () { });
        },
        onClick: function(row) {
			if (row.id <= 0) return;
			
			var obj = {};
			Object.assign(obj, row);
			
			this.$buefy.modal.open({				
                parent: this,
				props:{
					action: obj
				},
				events: {
					saved: this.saved
				},
                component: ActionModal,
                hasModalCard: true,
                customClass: 'custom-ekey-modal'
            });
        },
		saved: function() {
			this.loadAsyncData();
		}
    },
	created: function() {
		var $self = this;
		
		this.$eventBus.$on('get-actions-list', function() {			
			$self.loadAsyncData();
		});
	}
});