Vue.component('log-list', {
  data: function () {
    return {
      data: [],
	  filter: {
		  user: null,
		  object: null,
		  scanner: null
	  },
      total: 0,
      loading: false,
      page: 1,
      perPage: 20,
	  selected: null,
	  showAll: false,
	  users: [],
	  objects: [],
	  scanners: []
    }
  },
  methods: {    
    loadAsyncData: function() {
      var $self = this;
      this.loading = true;
      this.data = [];	  

      $.ajax({
        method: "POST",
        url: Ekey.Url.LogsList,
        data: {
            start: ($self.page - 1) * $self.perPage,
            limit: $self.perPage,
			get_all_records: $self.showAll ? 1 : 0,
			scanner_id: $self.filter.scanner,
			user_id: $self.filter.user,
			object_id: $self.filter.object
        },
        dataType: "json"
      })
        .done(function(response) {			
			$self.objects = response.unique_objects;
			$self.users = response.unique_users;
			$self.scanners = response.unique_scanners;
			
            $self.data = response.data;
            $self.total = response.total;
            $self.loading = false;
        })
        .fail(function(xhr, textStatus, errorThrown) {
			console.log(textStatus);
		});
    },   
    onPageChange: function(page) {
		this.page = page;		

		this.loadAsyncData();
    },
	getAllData: function(value){
		this.showAll = value;		
		
		this.loadAsyncData();
	},
	userSelected: function(value) {
		this.filter.user = value;
		
		this.loadAsyncData();
	},
	objectSelected: function(value) {
		this.filter.object = value;
		
		this.loadAsyncData();
	},
	scannerSelected: function(value) {
		this.filter.scanner = value;
		
		this.loadAsyncData();
	}
  },
  created: function() {
	  var $self = this;
	  
	  this.$eventBus.$on('get-logs-list', function() {
		  $self.loadAsyncData();
	  });
  }
});