Vue.component('rights-list-row', {
    props: ["item", "columns"],
    data: function() {
        return {
            obj: {},
            selected: false
        }
    },
    template: '<tr> <td data-label="User">{{item.id}}</td> <td data-label="Name">{{item.name}}</td> <td v-for="(c, idx) in columns" :key="idx" :data-label="c.id" v-bind:class="{\'inactive\': c.active == 0}"><input type="checkbox" v-model="item[c.id]" @click.stop @change.stop="obj[c.id] = item[c.id]; obj.id = item.id; send(obj)"></td></tr>',
    methods: {
        send: function(item) {
            this.obj = {};

            $.ajax({
                    method: "POST",
                    url: Ekey.Url.RightsList,
                    dataType: "text",
                    data: 'data=' + encodeURIComponent(JSON.stringify(item)) + '&xaction=update'
                })
                .done(function(response) {
                    console.log(response);
                })
                .fail(function(xhr, textStatus, errorThrown) {
                    console.log(textStatus);
                });
        }
    }
});

Vue.component('rights-list', {
    data: function() {
        return {
            data: [],
            loading: false,
            selected: null,
            scanners: []
        }
    },
    computed: {
        columns: function() {
            var arr = [];

            for (i = 0; i < this.scanners.length; i++) {
                arr.push({
                    id: 'allowed-' + this.scanners[i].scanner,
                    active: this.scanners[i].active
                });
            }

            return arr;
        }
    },
    methods: {
        getRightsList: function() {
            var $self = this;
            this.loading = true;
            this.data = [];

            $.ajax({
                    method: "GET",
                    cache: false,
                    url: Ekey.Url.RightsList,
                    dataType: "json"
                })
                .done(function(response) {
                    $self.data = response.data;

                    if (response.scanners != null) {
                        $self.scanners = response.scanners;
                    }

                    $self.loading = false;
                })
                .fail(function(xhr, textStatus, errorThrown) {
                    console.log(textStatus);
                });
        }
    },
    created: function() {
        var $self = this;

        this.$eventBus.$on('get-rights-list', function() {
            $self.getRightsList();
        });
    }
});