Scada.Ekey = {};
var $E = Scada.Ekey;
$E.tabs = [];

$E.reqUrl = function(request) {
    // return Scada.reqUrl('general', 'plugin') + '?plugin=ekey&request=' + request;
    // return Scada.reqUrl('general', 'plugin') + '?plugin=ekey&request=' + request;
    return '/apps/data/ekey/api.lp?request=' + request;
};

$E.UsersStore = new Ext.data.JsonStore({
    url: $E.reqUrl('users-list'),
    root: 'data',
    fields: [
        'id', 'name', 'description',
        'F0action', 'F1action', 'F2action', 'F3action', 'F4action',
        'F5action', 'F6action', 'F7action', 'F8action', 'F9action',
        'F10action'
    ]
});

$E.ActionsSelectStore = new Ext.data.JsonStore({
    url: $E.reqUrl('actions-select'),
    root: 'data',
    fields: ['action', 'name']
});

$E.UsersSelectStore = new Ext.data.JsonStore({
    url: $E.reqUrl('users-select'),
    root: 'data',
    fields: ['user', 'name']
});

$E.ScannersSelectStore = new Ext.data.JsonStore({
    url: $E.reqUrl('scanners-select'),
    root: 'data',
    fields: ['scanner', 'name']
});

$E.UsersEnrollFormWindow = new ExtFormWindow({
    id: 'ekey-users-enroll-form',
    window: {
        title: 'Enroll user',
        width: 460,
        height: 180
    },
    form: {
        url: $E.reqUrl('users-enroll'),
        items: [
            $def.select({
                name: 'user',
                fieldLabel: 'User',
                store: $E.UsersSelectStore,
                mode: 'local',
                valueField: 'user',
                displayField: 'name',
                allowBlank: false,
                hiddenName: 'user'
            }),
            {
                name: 'finger',
                fieldLabel: 'Finger (RFID=10)',
                xtype: 'spinnerfield',
                minValue: 0,
                maxValue: 10,
                allowBlank: false
            },
            $def.select({
                name: 'scanner',
                fieldLabel: 'Scanner',
                store: $E.ScannersSelectStore,
                mode: 'local',
                valueField: 'scanner',
                displayField: 'name',
                allowBlank: false,
                hiddenName: 'scanner'
            })
        ]
    },
});

$E.UsersDeleteCheck = function(_, val) {
    $E.UsersDeleteFormWindow.form.findField('finger').setDisabled(val);
};

$E.UsersDeleteCB = function() {
    $E.UsersStore.load();
};

$E.UsersDeleteFormWindow = new ExtFormWindow({
    id: 'ekey-users-delete-form',
    window: {
        title: 'Delete finger',
        width: 460,
        height: 210
    },
    form: {
        url: $E.reqUrl('users-delete'),
        items: [
            $def.select({
                name: 'user',
                fieldLabel: 'User',
                store: $E.UsersSelectStore,
                mode: 'local',
                valueField: 'user',
                displayField: 'name',
                allowBlank: false,
                hiddenName: 'user'
            }),
            { name: 'finger', fieldLabel: 'Finger (RFID=10)', xtype: 'spinnerfield', minValue: 0, maxValue: 10, allowBlank: false },
            {
                name: 'deleteall',
                fieldLabel: 'Delete all fingers',
                xtype: 'checkbox',
                listeners: { check: $E.UsersDeleteCheck }
            }
            /*,
                $def.select({
                  name: 'scanner', fieldLabel: 'Scanner', store: $E.ScannersSelectStore, mode: 'local',
                  valueField: 'scanner', displayField: 'name', allowBlank: false, hiddenName: 'scanner'
                })  */
        ]
    },
    events: { onFormSubmitComplete: $E.UsersDeleteCB, onFormSubmitFailed: $E.UsersDeleteCB }
});


$E.getFirstScanner = function() {
    var range = $E.ScannersStore.getRange(0, 0);
    return range.length ? range[0].data.id : 0;
};

$E.UsersEnroll = function(finger, user) {
    $E.UsersEnrollFormWindow.form.reset();
    $E.UsersEnrollFormWindow.show();
    $E.UsersEnrollFormWindow.form.setValues({
        finger: typeof finger == 'number' ? finger : 0,
        user: typeof user == 'number' ? user : 1,
        scanner: $E.getFirstScanner()
    });
};


$E.UsersDelete = function() {
    $E.UsersDeleteFormWindow.form.reset();
    $E.UsersDeleteFormWindow.show();
    $E.UsersDeleteFormWindow.form.setValues({
        finger: 0,
        user: 1,
        deleteall: false,
        scanner: $E.getFirstScanner()
    });
};

$E.UsersGrid = new Ext.grid.GridPanel($def.grid({
    store: $E.UsersStore,
    loadMask: true,
    bbar: [
        { text: 'Enroll', iconCls: 'icon-add', handler: $E.UsersEnroll },
        '-',
        { text: 'Delete', iconCls: 'icon-clear', handler: $E.UsersDelete }
    ],
    colModel: new Ext.grid.ColumnModel({
        columns: [
            { header: 'ID', width: 0.10, dataIndex: 'id' },
            { header: 'Name', width: 0.15, dataIndex: 'name' },
            { header: 'F0', width: 0.05, dataIndex: 'F0action' },
            { header: 'F1', width: 0.05, dataIndex: 'F1action' },
            { header: 'F2', width: 0.05, dataIndex: 'F2action' },
            { header: 'F3', width: 0.05, dataIndex: 'F3action' },
            { header: 'F4', width: 0.05, dataIndex: 'F4action' },
            { header: 'F5', width: 0.05, dataIndex: 'F5action' },
            { header: 'F6', width: 0.05, dataIndex: 'F6action' },
            { header: 'F7', width: 0.05, dataIndex: 'F7action' },
            { header: 'F8', width: 0.05, dataIndex: 'F8action' },
            { header: 'F9', width: 0.05, dataIndex: 'F9action' },
            { header: 'RFID', width: 0.05, dataIndex: 'F10action' },
            { header: 'Description', width: 0.20, dataIndex: 'description' }
        ]
    })
}));


$E.UsersSaveCB = function() {
    $E.UsersStore.reload();
    $E.UsersSelectStore.reload();
    if ($E.RightsControlStore) { $E.RightsControlStore.reload(); }
};

$E.UsersFormItems = [
    { name: 'id', xtype: 'hidden' },
    { name: 'name', fieldLabel: 'Name', allowBlank: false }
];

(function() {
    var i, name, label;
    for (i = 0; i < 11; i++) {
        name = 'F' + i + 'action';
        label = i == 10 ? 'RFID action' : 'Finger ' + i + ' action';

        $E.UsersFormItems.push($def.select({
            name: name,
            fieldLabel: label,
            store: $E.ActionsSelectStore,
            valueField: 'action',
            displayField: 'name',
            allowBlank: false,
            hiddenName: name,
            mode: 'local'
        }));
    }
})();

$E.UsersFormItems.push({ name: 'description', fieldLabel: 'Description', xtype: 'textarea', height: 90 });

$E.UsersFormWindow = new ExtFormWindow({
    id: 'ekey-users-form',
    window: {
        title: 'User information',
        width: 460,
        height: 510
    },
    form: {
        url: $E.reqUrl('users-save'),
        items: $E.UsersFormItems
    },
    events: { onFormSubmitComplete: $E.UsersSaveCB, onFormSubmitFailed: $E.UsersSaveCB }
});

$E.UsersContainer = new Ext.Container({
    id: 'EkeyUsers',
    title: 'Users',
    layout: 'border',
    items: $E.UsersGrid
});

$E.tabs.push($E.UsersContainer);

$E.ScannersStore = new Ext.data.JsonStore({
    url: $E.reqUrl('scanners-list'),
    root: 'data',
    // fields: ['id', 'name', 'description', 'serial', 'port', 'object', 'ufobject', 'active']
    //fields: ['id', 'name', 'description', 'serial', 'port', 'object', 'ufobject', 'active', 'is_rfid', 'is_relay', 'credentials_info', 'serial_txt', 'last_action_time', 'last_cfg_time']
    fields: ['id', 'name', 'description', 'serial', 'port', 'object', 'ufobject', 'active',
        'is_rfid', 'is_relay', 'is_authorized', 'credentials_info', 'serial_txt', 'licence_code', 'last_action_time', 'last_cfg_time', 'last_save_time'
    ]
});

$E.ScannersGrid = new Ext.grid.GridPanel($def.grid({
    store: $E.ScannersStore,
    loadMask: true,

    /* bbar: [
        { text: 'Start', iconCls: 'icon-accept' ,  handler: $E.UsersEnroll },
        '-',
        { text: 'Stop',  iconCls: 'icon-clear', handler: $E.UsersDelete }
    ], */

    viewConfig: {
        forceFit: true,
        getRowClass: function(record) {
            return (record.data.active == '1') ? 'objects-row-normal' : 'objects-row-error';
        }
    },
    colModel: new Ext.grid.ColumnModel({
        columns: [
            { header: 'ID', width: 0.03, dataIndex: 'id' },
            // { header: 'Addr', width: 0.03, dataIndex: 'serial'},
            { header: 'Name', width: 0.20, dataIndex: 'name' },
            //{ header: 'Serial number', width: 0.15, dataIndex: 'serial_txt' },
            // { header: 'Port', width: 0.15, dataIndex: 'port' },
            { header: 'Action object', width: 0.10, dataIndex: 'object', renderer: $O.objRenderer },
            { header: 'Finger object', width: 0.10, dataIndex: 'ufobject', renderer: $O.objRenderer },
            { header: 'Description', width: 0.20, dataIndex: 'description' },
            { header: 'Is RFID', width: 0.05, dataIndex: 'is_rfid' },
            { header: 'Is Relay', width: 0.05, dataIndex: 'is_relay' },
            { header: 'Is Activated', width: 0.05, dataIndex: 'is_authorized' },
            //{ header: 'Activation code', width: 0.07, dataIndex: 'licence_code' },
            { header: 'Finger/Users', width: 0.1, dataIndex: 'credentials_info' },
            // { header: 'Last change', width: 0.2, dataIndex: 'last_cfg_time' },
            //   { header: 'Last event', width: 0.2, dataIndex: 'last_action_time' },
            { header: 'Last saved', width: .15, dataIndex: 'last_save_time', xtype: 'timestampcolumn' }
            //{ header: 'Last change', width: .15, dataIndex: 'last_cfg_time', xtype: 'timestampcolumn' },
            //{ header: 'Last event', width: .15, dataIndex: 'last_action_time', xtype: 'timestampcolumn' },
            //{ header: $tr('delete' ), width:.03, xtype:'boolclscolumn', falseCls:'scada-cell-delete', dataIndex:'delete'}
        ]
    })
}));

/* 21.10.2018 AVI */
$E.ScannerOnDeleteConfirm = function() {
        "yes" == e && Ext.Ajax.request({
            url: $E.reqUrl('scanner-delete'),
            params: { "scanner": data.id },
            success: $E.reload
        })
    },

    $E.ScannersSaveCB = function() {
        $E.ScannersStore.reload();
        $E.ScannersSelectStore.reload();
    };

$E.ScannersFormWindow = new ExtFormWindow({
    id: 'ekey-scanners-form',
    window: {
        title: 'Scanner information',
        width: 460,
        height: 480
    },
    form: {
        url: $E.reqUrl('scanners-save'),
        items: [
            { name: 'id', xtype: 'hidden' },
            //{ name: 'serial', fieldLabel: 'Addr', xtype: 'displayfield' },
            { name: 'name', fieldLabel: 'Name', allowBlank: false },
            { name: 'description', fieldLabel: 'Description', xtype: 'textarea', height: 90 },
            { name: 'serial_txt', fieldLabel: 'Serial number', xtype: 'displayfield' },
            { name: 'licence_code', fieldLabel: 'Activation code' },
            { name: 'is_authorized', fieldLabel: 'Is Activated', xtype: 'checkbox' },
            $def.select({
                name: 'object',
                fieldLabel: 'Action object (boolean)',
                store: $O.createExtStore('ekey-action', Scada.dt.bool),
                mode: 'local',
                valueField: 'id',
                displayField: 'text',
                allowBlank: true,
                hiddenName: 'object'
            }),
            $def.select({
                name: 'ufobject',
                fieldLabel: 'Finger object (uint16)',
                store: $O.createExtStore('ekey-user-finger', Scada.dt.uint16),
                mode: 'local',
                valueField: 'id',
                displayField: 'text',
                allowBlank: true,
                hiddenName: 'ufobject'
            }),
            { name: 'is_rfid', fieldLabel: 'Is active RFID', xtype: 'checkbox' },
            { name: 'is_relay', fieldLabel: 'Is active Relay', xtype: 'checkbox' },
            //{ name: 'last_cfg_time', fieldLabel: 'Last changes date:', xtype: 'displayfield' },
            //{ name: 'last_action_time', fieldLabel: 'Last event date', xtype: 'displayfield' },
            //  { name: 'last_cfg_time', fieldLabel: 'Last changes date', xtype: 'datefield' },
            //  { name: 'last_action_time', fieldLabel: 'Last event date', xtype: 'datefield' },
            //  { name: 'last_save_time', fieldLabel: 'Last save date', xtype: 'datefield', value: 'last_save_time' },
            { name: 'credentials_info', fieldLabel: 'Fingers/Users:', xtype: 'displayfield' }
        ]
    },
    events: { onFormSubmitComplete: $E.ScannersSaveCB, onFormSubmitFailed: $E.ScannersSaveCB }
});

$E.ScannersContainer = new Ext.Container({
    id: 'EkeyScanners',
    title: 'Scanners',
    layout: 'border',
    items: $E.ScannersGrid
});

$E.tabs.push($E.ScannersContainer);

$E.RightsInit = function() {
    var fields = ['id', 'name'],
        columns = [
            { header: 'Name', dataIndex: 'name', width: 0.50 }
        ],
        data = $E.ScannersStore.getRange(),
        i, item;

    for (i = 0; i < data.length; i++) {
        item = data[i];

        fields.push('allowed-' + item.id);
        columns.push({ header: item.data.name, xtype: 'checkcolumn', dataIndex: 'allowed-' + item.id });
    }

    $E.RightsControlStore = new Ext.data.JsonStore({
        url: $E.reqUrl('rights-list'),
        root: 'data',
        fields: fields,
        writer: new Ext.data.JsonWriter({})
    });

    $E.RightsControlGrid = new Ext.grid.GridPanel($def.grid({
        store: $E.RightsControlStore,
        colModel: new Ext.grid.ColumnModel({ columns: columns })
    }));

    $E.RightsControlStore.load();
    $E.RightsContainer.add($E.RightsControlGrid);

    $E.MainPanel.setDisabled(false);
}

$E.RightsContainer = new Ext.Container({
    id: 'EkeyRights',
    title: 'Access Rights',
    layout: 'border',
    items: []
});

$E.tabs.push($E.RightsContainer);

$E.ActionsStore = new Ext.data.JsonStore({
    url: $E.reqUrl('actions-list'),
    root: 'data',
    fields: ['id', 'name', 'delay']
});

$E.ActionsGrid = new Ext.grid.GridPanel($def.grid({
    store: $E.ActionsStore,
    loadMask: true,

    colModel: new Ext.grid.ColumnModel({
        columns: [
            { header: 'ID', width: 0.10, dataIndex: 'id' },
            { header: 'Name', width: 0.50, dataIndex: 'name' },
            { header: 'Delay (seconds)', width: 0.40, dataIndex: 'delay' }
        ]
    })
}));

$E.ActionsSaveCB = function() {
    $E.ActionsStore.reload();
    $E.ActionsSelectStore.reload();
};

$E.ActionsFormWindow = new ExtFormWindow({
    id: 'ekey-actions-form',
    window: {
        title: 'Action information',
        width: 460,
        height: 160
    },
    form: {
        url: $E.reqUrl('actions-save'),
        items: [
            { name: 'id', xtype: 'hidden' },
            { name: 'name', fieldLabel: 'Name', allowBlank: false },
            { name: 'delay', fieldLabel: 'Delay (seconds)', xtype: 'spinnerfield', minValue: 1, maxValue: 300, allowBlank: false }
        ]
    },
    events: { onFormSubmitComplete: $E.ActionsSaveCB, onFormSubmitFailed: $E.ActionsSaveCB }
});

$E.ActionsContainer = new Ext.Container({
    id: 'EkeyActions',
    title: 'Actions',
    layout: 'border',
    items: $E.ActionsGrid
});

$E.tabs.push($E.ActionsContainer);

$E.LogsStore = new Ext.data.JsonStore({
    baseParams: { start: 0, limit: Config.perpage, get_all_records: 1},
    url: $E.reqUrl('logs-list'),
    root: 'data',
    fields: ['id', 'event', 'logtime', 'username', 'actioname', 'object', 'scannername']
});

$E.LogsPagination = new Ext.PagingToolbar({
    pageSize: Config.perpage,
    store: $E.LogsStore,
    displayInfo: true,
    displayMsg: $tr('logs_pages_hint'),
    emptyMsg: $tr('logs_pages_empty'),
    refreshText: false,
    firstText: false,
    lastText: false,
    nextText: false,
    prevText: false
});

$E.LogsGrid = new Ext.grid.GridPanel($def.grid({
    store: $E.LogsStore,
    bbar: $E.LogsPagination,

    colModel: new Ext.grid.ColumnModel({
        columns: [
            { header: 'Log time', width: .15, dataIndex: 'logtime', xtype: 'timestampcolumn' },
            { header: 'Event description', width: .25, dataIndex: 'event' },
            { header: 'Scanner', width: .20, dataIndex: 'scannername' },
            { header: 'User', width: .20, dataIndex: 'username' },
            { header: 'Action', width: .20, dataIndex: 'actioname' },
            { header: 'Object', width: .20, dataIndex: 'object', renderer: $O.objRenderer }
        ]
    })
}));

$E.LogsContainer = new Ext.Container({
    id: 'EkeyLogs',
    title: 'Logs',
    layout: 'border',
    items: $E.LogsGrid
});

$E.tabs.push($E.LogsContainer);

$E.MainPanel = new Ext.TabPanel({
    border: false,
    region: 'center',
    margins: '5 0 0 0',
    flex: 1,
    items: $E.tabs
});

$E.container = new Ext.Container({
    id: 'Ekey',
    title: 'Ekey',
    layout: 'border',
    items: $E.MainPanel
});

$E.update = function() {
    $E.LogsStore.reload();
    $E.ScannersStore.reload(); //  AV 23.05.2018  pielikts, lai arī skeneru saraksts automātiski atjaunojas pēc 10s
};


$E.onFocus = function() {
    if (!$E.ready) {
        $E.UsersStore.load();
        $E.ActionsSelectStore.load();
        $E.UsersSelectStore.load();
        $E.ScannersSelectStore.load();
        $E.ScannersStore.load();
        $E.ActionsStore.load();

        $E.reloaderTask = { run: $E.update, interval: 10000 };

        Scada.currentTask = $E.reloaderTask;
        Scada.taskRunner.start(Scada.currentTask);

        $E.ready = true;
    }
};

$E.init = function() {
    $E.ScannersStore.on('load', $E.RightsInit);

    $E.UsersFormWindow.init();
    $E.ScannersFormWindow.init();
    $E.ActionsFormWindow.init();
    $E.UsersEnrollFormWindow.init();
    $E.UsersDeleteFormWindow.init();

    $E.UsersGrid.on('cellclick', function(grid, row, col) {
        var data = grid.getStore().getAt(row).data,
            fname = grid.getColumnModel().getDataIndex(col);

        if (fname.indexOf('action') > 0) {
            var finger = fname.replace('F', '').replace('action', '').toNumber();
            $E.UsersEnroll(finger, data.id);
        } else {
            $E.UsersFormWindow.show();
            $E.UsersFormWindow.form.setValues(data);
        }
    });

    $E.ScannersGrid.on('cellclick', function(grid, row) {
        var data = grid.getStore().getAt(row).data;

        /* 21.10.2018 AVI*/
        //var i=grid.getColumnModel().getDataIndex(data.id);

        /*      'delete' == 'delete'? Ext.Msg.confirm
                ("Delete scanner","Are you sure you want to delete this scanner? It will appear again if it is still connected",
                $E.ScannerOnDeleteConfirm,
                {scanner:data.id}
                ) */

        /*   'delete' == 'delete'? { url: $E.reqUrl('scanner-delete'),
                                      params: {'scanner' : data.id},
                                      success:$E.reload}; */

        data.object = data.object || '';
        data.ufobject = data.ufobject || '';

        $E.ScannersFormWindow.show();
        $E.ScannersFormWindow.form.setValues(data);
    });

    $E.ActionsGrid.on('cellclick', function(grid, row) {
        var data = grid.getStore().getAt(row).data;

        if (data.id > 0) {
            var d = $E.ActionsFormWindow.form.findField('delay');
            d.setDisabled(data.delay == 0);
            d.setMinValue(data.delay == 0 ? 0 : 1);

            $E.ActionsFormWindow.show();
            $E.ActionsFormWindow.form.setValues(data);
        }
    });

    $E.MainPanel.setActiveTab(0);
    $E.MainPanel.setDisabled(true);
};

Scada.Modules.push(Scada.Ekey);